﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Optimization;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Problems.DataAnalysis;
using HeuristicLab.Problems.DataAnalysis.Symbolic;
using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views;

namespace HeuristicLab.EvolutionaryTracking {
  [Item("RegressionSolutionImpactValuesCalculator", "Wrapper class for calculating node impact values")]
  [StorableClass]
  class RegressionSolutionImpactValuesCalculator : InteractiveSymbolicRegressionSolutionSimplifierView {
    public IDictionary<ISymbolicExpressionTreeNode, double> CalculateImpactValues(ISymbolicExpressionTree tree, ISymbolicDataAnalysisExpressionTreeInterpreter interpreter, IRegressionProblemData problemData) {
      var model = new SymbolicRegressionModel(tree, interpreter);
      Content = new SymbolicRegressionSolution(model, problemData);
      return CalculateImpactValues(tree);
    }
  }
}
